holds(and(F1, F2), S) :- holds(F1,S), holds(F2,S).
holds(or(F1, F2), S) :- holds(F1,S).
holds(or(F1, F2), S) :- holds(F2,S).
holds(not(F1), S) :- \+ holds(F1,S).
holds(xor(F1,F2),S) :- holds(F1,S), \+ holds(F2,S).
holds(xor(F1,F2),S) :- holds(F2,S), \+ holds(F1,S).
 
holds(eg(F), S) :- holds(not(af(not(F))), S).
holds(ex(F), S1) :- step(S1,[S21,S22,S23,S24,S25,S26,S27,S28,S29,S2A]), holds(F,[S21,S22,S23,S24,S25,S26,S27,S28,S29,S2A]).
holds(eu(F, G), S) :- holds(G,S).
holds(eu(F, G), S) :- holds(F, S), holds(ex(eu(F, G)), S).
 
holds(ax(F), S) :- holds(not(ex(not(F))), S).
holds(ef(F), S) :- holds(eu(true, F), S).
holds(af(F), S) :- holds(F, S).
holds(af(F), S) :- holds(ax(af(F)), S).
holds(ag(F), S) :- holds(not(ef(not(F))), S).
holds(au(F1, F2), S) :- holds(and(not(eu(not(F2), and(not(F1), not(F2)))),
  not(eg(not(F2)))), S).

holds(true, S).

holds(init, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]).
holds(crit1, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S1).
holds(crit2, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S2).
holds(crit3, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S3).
holds(crit4, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S4).
holds(crit5, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S5).
holds(crit6, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S6).
holds(crit7, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S7).
holds(crit8, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S8).
holds(crit9, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S9).
holds(crit10, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- sat(S10).

holds(doublecrit, [S1, S2, S3, S4, S5, S6, S7, S8, S9, S10]) :-
  holds(or(or(or(or(or(and(crit1, crit2), or(and(crit1, crit3), and(crit1, crit4))),
                    or(and(crit1, crit5), or(and(crit1, crit6), and(crit1, crit7)))),
                 or(or(and(crit1, crit8), or(and(crit1, crit9), and(crit1, crit10))),
                    or(and(crit2, crit3), or(and(crit2, crit4), and(crit2, crit5))))),
              or(or(or(and(crit2, crit6), or(and(crit2, crit7), and(crit2, crit8))),
                    or(and(crit2, crit9), or(and(crit2, crit10), and(crit3, crit4)))),
                 or(or(and(crit3, crit5), or(and(crit3, crit6), and(crit3, crit7))),
                    or(and(crit3, crit8), and(crit3, crit9))))),
           or(or(or(or(and(crit3, crit10), or(and(crit4, crit5), and(crit4, crit6))),
                    or(and(crit4, crit7), or(and(crit4, crit8), and(crit4, crit9)))),
                 or(or(and(crit4, crit10), or(and(crit5, crit6), and(crit5, crit7))),
                    or(and(crit5, crit8), and(crit5, crit9)))),
              or(or(or(and(crit5, crit10), or(and(crit6, crit7), and(crit6, crit8))),
                    or(and(crit6, crit9), or(and(crit6, crit10), and(crit7, crit8)))),
                 or(or(and(crit7, crit9), or(and(crit7, crit10), and(crit8, crit9))),
                    or(and(crit8, crit10), and(crit9, crit10)))))), [S1, S2, S3, S4, S5, S6, S7, S8, S9, S10]).


step([S1, S2, S3, S4, S5, S6, S7, S8, S9, S10], [T1, T2, T3, T4, T5, T6, T7, T8, T9, T10]) :-
  action([S1,T1,T2,T3,T4,T5,T6,T7,T8,T9,T10]), action([S2,T2,T1,T3,T4,T5,T6,T7,T8,T9,T10]),
  action([S3,T3,T1,T2,T4,T5,T6,T7,T8,T9,T10]), action([S4,T4,T1,T2,T3,T5,T6,T7,T8,T9,T10]),
  action([S5,T5,T1,T2,T3,T4,T6,T7,T8,T9,T10]), action([S6,T6,T1,T2,T3,T4,T5,T7,T8,T9,T10]),
  action([S7,T7,T1,T2,T3,T4,T5,T6,T8,T9,T10]), action([S8,T8,T1,T2,T3,T4,T5,T5,T6,T9,T10]),
  action([S9,T9,T1,T2,T3,T4,T5,T6,T7,T8,T10]), action([S10,T10,T1,T2,T3,T4,T5,T6,T7,T8,T9]).

action([S, T, TT1, TT2, TT3, TT4, TT5, TT6, TT7, TT8, TT9]) :-
  sat(or(and(not(S),not(T)),
         or(and(not(S), and(not(TT1), and(not(TT2), and(not(TT3), and(not(TT4),
            and(not(TT5), and(not(TT6), and(not(TT7), and(not(TT8), and(not(TT9), T)))))))))),
            S))).

spec([S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- holds(ag(not(doublecrit)), [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]).

query([S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]) :- holds(init, [S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]),
                                           spec([S1,S2,S3,S4,S5,S6,S7,S8,S9,S10]).
