#ifndef STRINGSHOLDER_H
#define STRINGSHOLDER_H

#include <vector>

/**
 * This class holds strings found during scanning the program input.
 */
class StringsHolder
{
public:
   /**
    * Adds a string to the holder.
    * \param text the string.
    * \return A pointer to a copy of the string.
    */
   char *add(const char *text);
   
   /**
    * Garbage collector that clears all memory allocated for the
    * string copies.
    */
   void delete_strings();
   
private:
   
   /**
    * The string copies kept.
    */
   std::vector<char*> strings;
};

#endif
